# NHDSPy
[![Documentation Status](https://readthedocs.org/projects/nhdspy/badge/?version=latest)](https://nhdspy.readthedocs.io/en/latest/?badge=latest)
[![Build Status](https://travis-ci.org/dstansby/nhdspy.svg?branch=master)](https://travis-ci.org/dstansby/nhdspy)
[![codecov](https://codecov.io/gh/dstansby/NHDSPy/branch/master/graph/badge.svg)](https://codecov.io/gh/dstansby/NHDSPy)

Python wrapper for the NHDS dispersion relation solver. For the original NHDS code see https://github.com/danielver02/NHDS.

If you use this software to produce data for publication, please cite the NHDS paper: http://iopscience.iop.org/article/10.3847/2515-5172/aabfe3

This is NHDS - The New Hampshire Dispersion relation Solver

Copyright (C) 2018 - Daniel Verscharen (d.verscharen@ucl.ac.uk)
Mullard Space Science Laboratory, University College London
Space Science Center, University of New Hampshire

NHDS solves the linear hot-plasma dispersion relation based on the Vlasov-Maxwell set of
equations.

NHDS has the following requirements:

    make
    Fortran 90 compiler
    HDF5

Compile the code by executing

    mkdir obj bin
    make

in the main directory. Then run NHDS with

    ./bin/NHDS

The plasma and numerical parameters are set in the file parameters.in.
The code requires the folders src, bin, and obj in the main directory.

module input_params
  implicit none
  save
  integer :: numspec,numiter,nmax,mmax,ampl_mode
  integer :: vxsteps,vysteps,vzsteps,timesteps,num_periods,ksteps,theta_steps
  double precision :: vtherm(10),alpha(10),Omega(10),ell(10),vdrift(10),mass(10),charge(10),beta(10),density(10)
  double precision :: vAc,det_D_threshold,Bessel_zero,ampl,theta_range(2),krange(2)
  double precision :: Bessel_zero_deltaf,vxrange(2),vyrange(2),vzrange(2)
  double complex :: initial_guess
  double complex, parameter ::  uniti=(0.d0,1.d0)
  double precision,parameter :: M_PI=3.141592654d0
  logical :: output_warning,damping,periods,const_r,output_mom,output_EB,kth_file
  character*20 :: kth_filename
end module input_params

! NHDS is a numerical solver to the linear hot-plasma dispersion relation
! Copyright (C) 2018 Daniel Verscharen (d.verscharen@ucl.ac.uk)
!All rights reserved.
!
!Redistribution and use in source and binary forms, with or without
!modification, are permitted provided that the following conditions are met:
!
!1. Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!2. Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
!THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
!ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
!WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
!DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
!ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
!(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
!LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
!ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
!(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
!SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
!The views and conclusions contained in the software and documentation are those
!of the authors and should not be interpreted as representing official policies,
!either expressed or implied, of the NHDS project.

program NHDS
use input_params
implicit none
integer :: j,i,l
double complex :: x
double precision, allocatable, dimension(:) :: kk,theta
double complex, allocatable, dimension(:) :: guesses
double precision :: dk, dth
character*30 :: filename

dk=0.; dth=0.
call get_command_argument(1,filename); filename=adjustl(filename)
call set_parameters(filename)

allocate(kk(ksteps))
if (kth_file) then
   ! if reading k,th values from file
   ! ksteps=theta_steps=number of (k,th) pairs in input file
   allocate(theta(ksteps),guesses(ksteps))
   kth_filename=adjustl(kth_filename)
   open(unit=793,file=kth_filename)
   read(793,*) kk
   read(793,*) theta
   read(793,*) guesses
   close(793)
else
   allocate(theta(theta_steps))
   ! If using range of k and theta, create the kk, theta arrays to use
   if (ksteps .gt. 1) dk = (krange(2)-krange(1))/(1.d0*ksteps-1.d0)
   if (theta_steps .gt. 1) dth = (theta_range(2)-theta_range(1))/(1.d0*theta_steps-1.d0)
   do i=1,ksteps
      kk(i)=krange(1)+dk*(1.d0*i-1.d0)
    enddo
   do i=1,theta_steps
      theta(i)=theta_range(1)+dth*(1.d0*i-1.d0)
   enddo
endif

do j=1,numspec
  Omega(j)=charge(j)/mass(j)
  ell(j)=sqrt(mass(j)/(density(j)*charge(j)*charge(j)))
  vtherm(j)=sqrt(beta(j)/(density(j)*mass(j)))
enddo

open(unit=10,file='output_'//trim(filename)//'.dat',status='replace',action='write')
write (10,*) '# kk, theta, omega, gamma, Re(Ey/Ex), Im(Ey/Ex), Re(Ez/Ex), Im(Ez/Ex), energy, quality'

if (output_mom) then
   open(unit=11,file='Plasma_'//trim(filename)//'.dat',status='replace',action='write')
   write (11,*) '# kk, theta, Re(dn), Im(dn), Re(dUperpx), Im(dUperpx), Re(dUperpy), Im(dUperpy), Re(dUpar), Im(dUpar)'
endif
if (output_EB) then
   open(unit=12,file='EB_'//trim(filename)//'.dat',status='replace',action='write')
   write (14,*) '# kk, theta, Re(Ex), Im(Ex), Re(Ey), Im(Ey), Re(Ez), Im(Ez), Re(Bx), Im(Bx), Re(By), Im(By), Re(Bz), Im(Bz)'
endif

if (kth_file) then
   do i=1,ksteps
      x = guesses(i)
      call compute(kk(i),theta(i),x,output_mom,output_EB)
   enddo
else
   do l=1,theta_steps
      x=initial_guess ! guess w in units of wci:
      do i=1,ksteps
         call compute(kk(i),theta(l),x, output_mom,output_EB)
         if (i .eq. 1) initial_guess=x
      enddo
   enddo
endif

close(10)
close(11)
close(12)

end program

subroutine compute(kk,theta,x,outputm,outputeb)
   use input_params
   double precision, intent(in) :: kk, theta
   double complex, intent(inout) :: x
   logical, intent(in) :: outputm, outputeb
   double complex :: pol,polz,xi,deltaRj, Ek(3), Bk(3)
   double complex :: dUperpx,dUperpy,dUpar, Avec(3)
   double precision :: kperp,kz,energy,gamma_contribution(10)
   real :: quality
   integer :: j
   kz=kk*cos(theta*M_PI/180.d0)
   kperp=kk*sin(theta*M_PI/180.d0)

   call newton_method(x,kz,kperp,quality)
   call calc_polarization(pol,polz,x,kz,kperp)
   call waveenergy(energy,x,kz,kperp,gamma_contribution)

!  if (i .eq. 1) initial_guess=x

   if (outputm) then
     do j=1,numspec
       call calc_xi(xi,j,pol,polz,x,kz,kperp)
       ! second parameter is index of species
       call calc_fluctRj(deltaRj,dUperpx,dUperpy,dUpar,j,pol,polz,x,kz,kperp)
       ! fifth parameter is index of species
       write(11,'(10F14.5)') kk, theta, real(xi), aimag(xi), real(dUperpx), &
                            aimag(dUperpx), real(dUperpy), aimag(dUperpy), &
                            real(dUpar), aimag(dUpar)
     enddo
     write(11,*) ''
   endif

   if (outputeb) then

     if (ampl_mode.EQ.1) then
     	! Avec fulfills the equation  c * dE = Avec * vA * dB_x
     	Avec(1)=uniti*x/(kz*pol)
     	Avec(2)=-x/kz
     	Avec(3)=polz*uniti*x/(kz*pol)
     else if (ampl_mode.EQ.2) then
     	! Avec fulfills the equation  c * dE = Avec * vA * dB_y
     	Avec(1)=x/(kz-polz*kperp)
     	Avec(2)=uniti*pol*x/(kz-polz*kperp)
     	Avec(3)=x/((kz/polz)-kperp)
     else if (ampl_mode.EQ.3) then
     	! Avec fulfills the equation  c * dE = Avec * vA * dB_z
     	Avec(1)=-uniti*x/(kperp*pol)
     	Avec(2)=x/kperp
     	Avec(3)=-uniti*x*polz/(kperp*pol)
     endif


      Ek(1)=Avec(1)*vAc*ampl
      Ek(2)=Avec(2)*vAc*ampl
      Ek(3)=Avec(3)*vAc*ampl

      Bk(1)=-kz*Ek(2)/(x*vAc)
      Bk(2)=(kz*Ek(1)-kperp*Ek(3))/(x*vAc)
      Bk(3)=kperp*Ek(2)/(x*vAc)

      write(12,'(14E14.5)') kk, theta,   real(Ek(1)), aimag(Ek(1)), real(Ek(2))&
                          ,aimag(Ek(2)), real(Ek(3)), aimag(Ek(3)), real(Bk(1))&
                          ,aimag(Bk(1)), real(Bk(2)), aimag(Bk(2)), real(Bk(3))&
                          ,aimag(Bk(3))
   endif

!  write (*, '(10F9.5)') kk(i),theta(j),real(x),aimag(x),real(pol),aimag(pol),&
!                        real(polz),aimag(polz),energy,quality
   write (*, '(3F10.5,3E14.5)' ) kk, theta, real(x), aimag(x), quality
   write (10,'(3F10.5,7E14.5)') kk, theta, real(x), aimag(x), real(pol*uniti), aimag(pol*uniti),&
                          real(polz), aimag(polz), energy, quality

! if (i.EQ.10) call write_delta_f(1,kz,x,pol,polz) ! first parameter is index of species
end subroutine compute

! This file is part of NHDS
! Copyright (C) 2018 Daniel Verscharen (d.verscharen@ucl.ac.uk)
!All rights reserved.
!
!Redistribution and use in source and binary forms, with or without
!modification, are permitted provided that the following conditions are met:
!
!1. Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!2. Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
!THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
!ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
!WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
!DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
!ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
!(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
!LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
!ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
!(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
!SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
!The views and conclusions contained in the software and documentation are those
!of the authors and should not be interpreted as representing official policies,
!either expressed or implied, of the NHDS project.

double complex function dispfunct(zeta,kpos)
use input_params
implicit none


double complex :: zeta
logical :: flag,kpos
double precision :: U,V,XI,YI



XI=1.d0*real(zeta)
YI=1.d0*aimag(zeta)



if (kpos) then
   call WOFZ(XI,YI,U,V,flag)
   dispfunct = uniti*sqrt(M_PI)*(U+uniti*V)
else
   call WOFZ(-XI,-YI,U,V,flag)
   dispfunct = -uniti*sqrt(M_PI)*(U+uniti*V)
endif
end function



!Based on
!G.P.M. Poppe, C.M.J. Wijers, "More Efficient Computation of the Complex Error-Function",
!ACM Trans. Math. Software 16, 47 (1990).



!C      ALGORITHM 680, COLLECTED ALGORITHMS FROM ACM.
!C      THIS WORK PUBLISHED IN TRANSACTIONS ON MATHEMATICAL SOFTWARE,
!C      VOL. 16, NO. 1, PP. 47.
      SUBROUTINE WOFZ (XI, YI, U, V, FLAG)
!C
!C  GIVEN A COMPLEX NUMBER Z = (XI,YI), THIS SUBROUTINE COMPUTES
!C  THE VALUE OF THE FADDEEVA-FUNCTION W(Z) = EXP(-Z**2)*ERFC(-I*Z),
!C  WHERE ERFC IS THE COMPLEX COMPLEMENTARY ERROR-FUNCTION AND I
!C  MEANS SQRT(-1).
!C  THE ACCURACY OF THE ALGORITHM FOR Z IN THE 1ST AND 2ND QUADRANT
!C  IS 14 SIGNIFICANT DIGITS; IN THE 3RD AND 4TH IT IS 13 SIGNIFICANT
!C  DIGITS OUTSIDE A CIRCULAR REGION WITH RADIUS 0.126 AROUND A ZERO
!C  OF THE FUNCTION.
!C  ALL REAL VARIABLES IN THE PROGRAM ARE DOUBLE PRECISION.
!C
!C
!C  THE CODE CONTAINS A FEW COMPILER-DEPENDENT PARAMETERS :
!C     RMAXREAL = THE MAXIMUM VALUE OF RMAXREAL EQUALS THE ROOT OF
!C                RMAX = THE LARGEST NUMBER WHICH CAN STILL BE
!C                IMPLEMENTED ON THE COMPUTER IN DOUBLE PRECISION
!C                FLOATING-POINT ARITHMETIC
!C     RMAXEXP  = LN(RMAX) - LN(2)
!C     RMAXGONI = THE LARGEST POSSIBLE ARGUMENT OF A DOUBLE PRECISION
!C                GONIOMETRIC FUNCTION (DCOS, DSIN, ...)
!C  THE REASON WHY THESE PARAMETERS ARE NEEDED AS THEY ARE DEFINED WILL
!C  BE EXPLAINED IN THE CODE BY MEANS OF COMMENTS
!C
!C
!C  PARAMETER LIST
!C     XI     = REAL      PART OF Z
!C     YI     = IMAGINARY PART OF Z
!C     U      = REAL      PART OF W(Z)
!C     V      = IMAGINARY PART OF W(Z)
!C     FLAG   = AN ERROR FLAG INDICATING WHETHER OVERFLOW WILL
!C              OCCUR OR NOT; TYPE LOGICAL;
!C              THE VALUES OF THIS VARIABLE HAVE THE FOLLOWING
!C              MEANING :
!C              FLAG=.FALSE. : NO ERROR CONDITION
!C              FLAG=.TRUE.  : OVERFLOW WILL OCCUR, THE ROUTINE
!C                             BECOMES INACTIVE
!C  XI, YI      ARE THE INPUT-PARAMETERS
!C  U, V, FLAG  ARE THE OUTPUT-PARAMETERS
!C
!C  FURTHERMORE THE PARAMETER FACTOR EQUALS 2/SQRT(PI)
!C
!C  THE ROUTINE IS NOT UNDERFLOW-PROTECTED BUT ANY VARIABLE CAN BE
!C  PUT TO 0 UPON UNDERFLOW;
!C
!C  REFERENCE - GPM POPPE, CMJ WIJERS; MORE EFFICIENT COMPUTATION OF
!C  THE COMPLEX ERROR-FUNCTION, ACM TRANS. MATH. SOFTWARE.
!C
!*
!*
!*
!*
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)

      LOGICAL A, B, FLAG
PARAMETER (FACTOR=1.12837916709551257388D0,RMAXREAL = 0.5D+154,RMAXEXP  = 708.503061461606D0,&
&RMAXGONI = 3.53711887601422D+15)

      FLAG = .FALSE.

      XABS = DABS(XI)
      YABS = DABS(YI)
      X    = XABS/6.3
      Y    = YABS/4.4
!*
!C
!C     THE FOLLOWING IF-STATEMENT PROTECTS
!C     QRHO = (X**2 + Y**2) AGAINST OVERFLOW
!C
      IF ((XABS.GT.RMAXREAL).OR.(YABS.GT.RMAXREAL)) GOTO 100

      QRHO = X**2 + Y**2

      XABSQ = XABS**2
      XQUAD = XABSQ - YABS**2
      YQUAD = 2*XABS*YABS

     A     = QRHO.LT.0.085264D0

      IF (A) THEN
!C
!C  IF (QRHO.LT.0.085264D0) THEN THE FADDEEVA-FUNCTION IS EVALUATED
!C  USING A POWER-SERIES (ABRAMOWITZ/STEGUN, EQUATION (7.1.5), P.297)
!C  N IS THE MINIMUM NUMBER OF TERMS NEEDED TO OBTAIN THE REQUIRED
!C  ACCURACY
!C
        QRHO  = (1-0.85*Y)*DSQRT(QRHO)
        N     = IDNINT(6 + 72*QRHO)
        J     = 2*N+1
        XSUM  = 1.0/J
        YSUM  = 0.0D0
        DO 10 I=N, 1, -1
          J    = J - 2
          XAUX = (XSUM*XQUAD - YSUM*YQUAD)/I
          YSUM = (XSUM*YQUAD + YSUM*XQUAD)/I
          XSUM = XAUX + 1.0/J
 10     CONTINUE
        U1   = -FACTOR*(XSUM*YABS + YSUM*XABS) + 1.0
        V1   =  FACTOR*(XSUM*XABS - YSUM*YABS)
        DAUX =  DEXP(-XQUAD)
        U2   =  DAUX*DCOS(YQUAD)
        V2   = -DAUX*DSIN(YQUAD)

        U    = U1*U2 - V1*V2
        V    = U1*V2 + V1*U2

      ELSE
!C
!C  IF (QRHO.GT.1.O) THEN W(Z) IS EVALUATED USING THE LAPLACE
!C  CONTINUED FRACTION
!C  NU IS THE MINIMUM NUMBER OF TERMS NEEDED TO OBTAIN THE REQUIRED
!C  ACCURACY
!C
!C  IF ((QRHO.GT.0.085264D0).AND.(QRHO.LT.1.0)) THEN W(Z) IS EVALUATED
!C  BY A TRUNCATED TAYLOR EXPANSION, WHERE THE LAPLACE CONTINUED FRACTION
!C  IS USED TO CALCULATE THE DERIVATIVES OF W(Z)
!C  KAPN IS THE MINIMUM NUMBER OF TERMS IN THE TAYLOR EXPANSION NEEDED
!C  TO OBTAIN THE REQUIRED ACCURACY
!C  NU IS THE MINIMUM NUMBER OF TERMS OF THE CONTINUED FRACTION NEEDED
!C  TO CALCULATE THE DERIVATIVES WITH THE REQUIRED ACCURACY
!

        IF (QRHO.GT.1.0) THEN
          H    = 0.0D0
          KAPN = 0
          QRHO = DSQRT(QRHO)
          NU   = IDINT(3 + (1442/(26*QRHO+77)))
        ELSE
          QRHO = (1-Y)*DSQRT(1-QRHO)
          H    = 1.88*QRHO
          H2   = 2*H
          KAPN = IDNINT(7  + 34*QRHO)
          NU   = IDNINT(16 + 26*QRHO)
        ENDIF

        B = (H.GT.0.0)

        IF (B) QLAMBDA = H2**KAPN

        RX = 0.0
        RY = 0.0
        SX = 0.0
        SY = 0.0

        DO 11 N=NU, 0, -1
          NP1 = N + 1
          TX  = YABS + H + NP1*RX
          TY  = XABS - NP1*RY
          C   = 0.5/(TX**2 + TY**2)
          RX  = C*TX
          RY  = C*TY
          IF ((B).AND.(N.LE.KAPN)) THEN
            TX = QLAMBDA + SX
            SX = RX*TX - RY*SY
            SY = RY*TX + RX*SY
            QLAMBDA = QLAMBDA/H2
          ENDIF
 11     CONTINUE

        IF (H.EQ.0.0) THEN
          U = FACTOR*RX
          V = FACTOR*RY
        ELSE
          U = FACTOR*SX
          V = FACTOR*SY
        END IF

        IF (YABS.EQ.0.0) U = DEXP(-XABS**2)

      END IF

!C  EVALUATION OF W(Z) IN THE OTHER QUADRANTS

      IF (YI.LT.0.0) THEN
        IF (A) THEN
          U2    = 2*U2
          V2    = 2*V2
        ELSE
          XQUAD =  -XQUAD

!         THE FOLLOWING IF-STATEMENT PROTECTS 2*EXP(-Z**2)
!        AGAINST OVERFLOW

          IF ((YQUAD.GT.RMAXGONI).OR. (XQUAD.GT.RMAXEXP)) GOTO 100

          W1 =  2*DEXP(XQUAD)
          U2  =  W1*DCOS(YQUAD)
          V2  = -W1*DSIN(YQUAD)
        END IF

        U = U2 - U
        V = V2 - V
        IF (XI.GT.0.0) V = -V
      ELSE
        IF (XI.LT.0.0) V = -V
      END IF

      RETURN

  100 FLAG = .TRUE.
      RETURN

      END

! This file is part of NHDS
! Copyright (C) 2018 Daniel Verscharen (d.verscharen@ucl.ac.uk)
!All rights reserved.
!
!Redistribution and use in source and binary forms, with or without
!modification, are permitted provided that the following conditions are met:
!
!1. Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!2. Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
!THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
!ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
!WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
!DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
!ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
!(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
!LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
!ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
!(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
!SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
!The views and conclusions contained in the software and documentation are those
!of the authors and should not be interpreted as representing official policies,
!either expressed or implied, of the NHDS project.

subroutine calc_xi(xi,j,pol,polz,x,kz,kperp)
use input_params
implicit none
double precision :: kz,kperp
double complex :: x,pol,polz,Avec(3),xi,chi(3,3)
integer :: j

! This subroutine calculates the quantity xi in dn/n_0 = xi * dB_(x,y,z)/B_0


if (ampl_mode.EQ.1) then
	! Avec fulfills the equation  c * dE = Avec * vA * dB_x
	Avec(1)=uniti*x/(kz*pol)
	Avec(2)=-x/kz
	Avec(3)=polz*uniti*x/(kz*pol)
else if (ampl_mode.EQ.2) then
	! Avec fulfills the equation  c * dE = Avec * vA * dB_y
	Avec(1)=x/(kz-polz*kperp)
	Avec(2)=uniti*pol*x/(kz-polz*kperp)
	Avec(3)=x/((kz/polz)-kperp)
else if (ampl_mode.EQ.3) then
	! Avec fulfills the equation  c * dE = Avec * vA * dB_z
	Avec(1)=-uniti*x/(kperp*pol)
	Avec(2)=x/kperp
	Avec(3)=-uniti*x*polz/(kperp*pol)
endif


call calc_chi(chi,j,kz,kperp,x)

! continuity equation (as in Stix 10-75)
xi=kperp*(chi(1,1)*Avec(1)+chi(1,2)*Avec(2)+chi(1,3)*Avec(3))
xi=xi+kz*(chi(3,1)*Avec(1)+chi(3,2)*Avec(2)+chi(3,3)*Avec(3))
xi=-uniti*xi*ampl/(density(j)*charge(j))

! Normalization: chi is different by a factor vAc*vAc from Stix' definition:
! our chi divided by (v_A/c)^2 is equal to Stix' chi.

end subroutine



subroutine calc_fluctRj(deltaRj,dUperpx,dUperpy,dUpar,j,pol,polz,x,kz,kperp)
use input_params
implicit none
double precision :: kz,kperp,z,besselI,BInz,dBInzdz,d2BInzdz2
double complex :: x,pol,polz,Avec(3),dispfunct,zeta,deltaRj,chi(3,3)
double complex :: Z0,Z1,Z2,Z3,dpperp,dppar,Exterm,Eyterm,Ezterm,dUpar
double complex :: dUperpx,dUperpy,Ubar
logical :: kpos,Bessel_run
integer :: j,n,nmaxrun

! This subroutine calculates the pressure fluctuations that are
! needed to calculate the quantity R_j (the fluctuations in the temperature anisotropy of species j)
! define ampl = dBz/B0

z=0.5d0*(kperp*vtherm(j)/Omega(j))*(kperp*vtherm(j)/Omega(j))*alpha(j)

kpos=.TRUE.
if (kz.LT.0.d0) kpos=.FALSE.


if (ampl_mode.EQ.1) then
	! Avec fulfills the equation  c * dE = Avec * vA * dB_x
	Avec(1)=uniti*x/(kz*pol)
	Avec(2)=-x/kz
	Avec(3)=polz*uniti*x/(kz*pol)
else if (ampl_mode.EQ.2) then
	! Avec fulfills the equation  c * dE = Avec * vA * dB_y
	Avec(1)=x/(kz-polz*kperp)
	Avec(2)=uniti*pol*x/(kz-polz*kperp)
	Avec(3)=x/((kz/polz)-kperp)
else if (ampl_mode.EQ.3) then
	! Avec fulfills the equation  c * dE = Avec * vA * dB_z
	Avec(1)=-uniti*x/(kperp*pol)
	Avec(2)=x/kperp
	Avec(3)=-uniti*x*polz/(kperp*pol)
endif

! This is for the calculation of dUpar and dUperp from the definition of the current density
! and the susceptibility. These expressions are equivalent to taking the first moment
! of delta f and lead to the same result.
call calc_chi(chi,j,kz,kperp,x)
dUpar=chi(3,1)*Avec(1)+chi(3,2)*Avec(2)+chi(3,3)*Avec(3)
dUpar=-uniti*x*dUpar*ampl/(density(j)*charge(j))

dUperpx=chi(1,1)*Avec(1)+chi(1,2)*Avec(2)+chi(1,3)*Avec(3)
dUperpx=-uniti*x*dUperpx*ampl/(density(j)*charge(j))

dUperpy=chi(2,1)*Avec(1)+chi(2,2)*Avec(2)+chi(2,3)*Avec(3)
dUperpy=-uniti*x*dUperpy*ampl/(density(j)*charge(j))



! This is without dUpar:
Ubar=vdrift(j)!+dUpar

! Normalization: chi is different by a factor vAc*vAc from Stix' definition:
! our chi divided by (v_A/c)^2 is equal to Stix' chi.

! dUperpx and dUperpy need to be small so that the following calculation is accurate.

!determine maximum n for Besselfunction:
nmaxrun=nmax
n=0
Bessel_run=.TRUE.
do while (Bessel_run)
  if ((n.GE.nmax).OR.(besselI(n,z).LT.Bessel_zero)) then
     nmaxrun=n
     Bessel_run=.FALSE.
  endif
  n=n+1
enddo

if ((n.GE.nmax).AND.(output_warning)) then
 write (*,*) "WARNING: Insufficient order of Bessel function (nmax)."
 stop
endif


! dpperp is deltapperp^2 / ampl in units of the magnetic background pressure
! dppar is deltappar^2 / ampl in units of the magnetic background pressure.

dpperp=0.d0
dppar=0.d0


! Run over all n:
do n=-nmaxrun,nmaxrun

	if (n.GE.0) then
		BInz=1.d0*besselI(n,z)
		dBInzdz=besselI(n+1,z)+1.d0*n*BInz/z
	else
		BInz=1.d0*besselI(-n,z)
		dBInzdz=besselI(-n-1,z)+1.d0*n*BInz/z
	endif

	if (n.GE.2) d2BInzdz2=0.25d0*(besselI(n-2,z)+2.d0*besselI(n,z)+besselI(n+2,z))
	if (n.LE.-2) d2BInzdz2=0.25d0*(besselI(2-n,z)+2.d0*besselI(-n,z)+besselI(-2-n,z))
	if (n.EQ.1) d2BInzdz2=0.25d0*(3.d0*besselI(1,z)+besselI(3,z))
	if (n.EQ.-1) d2BInzdz2=0.25d0*(besselI(3,z)+3.d0*besselI(1,z))
	if (n.EQ.0) d2BInzdz2=0.5d0*(besselI(2,z)+besselI(0,z))

	zeta=(x-kz*vdrift(j)-1.d0*n*Omega(j))/(kz*vtherm(j))

	! determine Stix' (normalized) dispersion functions:
	! (normalized as follows: Z0, Z1/vA, Z2*vA^2, Z3*vA^3)
	Z0=dispfunct(zeta,kpos)
	Z1=vtherm(j)*(1.d0+(zeta+vdrift(j)/vtherm(j))*Z0)
	Z2=(zeta+2.d0*vdrift(j)/vtherm(j)+Z0*(zeta+vdrift(j)/vtherm(j))**(2.d0))
	Z2=Z2*vtherm(j)*vtherm(j)
	Z3=0.5d0+zeta*zeta+3.d0*zeta*vdrift(j)/vtherm(j)+3.d0*(vdrift(j)/vtherm(j))**(2.d0)
	Z3=Z3+Z0*(zeta+vdrift(j)/vtherm(j))**(3.d0)
	Z3=Z3*vtherm(j)*vtherm(j)*vtherm(j)


	! This is for the calculation of dpperp:

	Exterm=Avec(1)*(BInz+z*(dBinzdz-BInz))*(1.d0*n)*Omega(j)/kperp
	Eyterm=-uniti*Avec(2)*(BInz-dBInzdz-0.5d0*z*(BInz+d2BInzdz2)+z*dBInzdz)
	Eyterm=Eyterm*kperp*vtherm(j)*vtherm(j)*alpha(j)/Omega(j)
	Ezterm=(1.d0-1.d0*n*Omega(j)/x)*alpha(j)*(Z1-vdrift(j)*Z0)+1.d0*n*Omega(j)*Z1/x
	Ezterm=Ezterm*Avec(3)*(BInz+z*(dBInzdz-BInz))

	dpperp=dpperp+(Exterm+Eyterm)*(Z0-kz*Z1/x+alpha(j)*kz*(Z1-vdrift(j)*Z0)/x)+Ezterm


	! This is for the calculation of dppar:

	Exterm=alpha(j)*kz*(Z3-vdrift(j)*Z2-2.d0*Ubar*Z2+2.d0*vdrift(j)*Ubar*Z1+Ubar*Ubar*Z1-vdrift(j)*Ubar*Ubar*Z0)/x
	Exterm=Exterm+Z2-2.d0*Ubar*Z1+Ubar*Ubar*Z0
	Exterm=Exterm-kz*(Z3-2.d0*Ubar*Z2+Ubar*Ubar*Z1)/x
	Exterm=Exterm*Avec(1)*BInz*(1.d0*n)*Omega(j)/(kperp*vtherm(j)*vtherm(j)*alpha(j))
	Eyterm=alpha(j)*kz*(Z3-vdrift(j)*Z2-2.d0*Ubar*Z2+2.d0*vdrift(j)*Ubar*Z1+Ubar*Ubar*Z1-vdrift(j)*Ubar*Ubar*Z0)/x
	Eyterm=Eyterm+Z2-2.d0*Ubar*Z1+Ubar*Ubar*Z0
	Eyterm=Eyterm-kz*(Z3-2.d0*Ubar*Z2+Ubar*Ubar*Z1)/x
	Eyterm=-uniti*Eyterm*Avec(2)*(BInz-dBInzdz)*kperp/(2.d0*Omega(j))
	Ezterm=(1.d0-(1.d0*n)*Omega(j)/x)*(Z3-vdrift(j)*Z2-2.d0*Ubar*Z2+2.d0*vdrift(j)*Ubar*Z1+Ubar*Ubar*Z1-vdrift(j)*Ubar*Ubar*Z0)
	Ezterm=Ezterm+(1.d0*n)*Omega(j)*(Z3-2.d0*Ubar*Z2+Ubar*Ubar*Z1)/(alpha(j)*x)
	Ezterm=Ezterm*Avec(3)*BInz/(vtherm(j)*vtherm(j))



	dppar=dppar+Exterm+Eyterm+Ezterm

enddo


dpperp=-2.d0*uniti*mass(j)*density(j)*Omega(j)*dpperp*exp(-z)/(kz*vtherm(j))
dppar=-4.d0*uniti*mass(j)*density(j)*Omega(j)*dppar*exp(-z)/(kz*vtherm(j))


deltaRj = (vtherm(j)*vtherm(j)*alpha(j)+ampl*dpperp/(density(j)*mass(j)))
deltaRj = deltaRj /(vtherm(j)*vtherm(j)+ampl*dppar/(density(j)*mass(j)))

end subroutine

! This file is part of NHDS
! Copyright (C) 2018 Daniel Verscharen (d.verscharen@ucl.ac.uk)
!All rights reserved.
!
!Redistribution and use in source and binary forms, with or without
!modification, are permitted provided that the following conditions are met:
!
!1. Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!2. Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
!THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
!ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
!WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
!DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
!ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
!(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
!LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
!ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
!(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
!SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
!The views and conclusions contained in the software and documentation are those
!of the authors and should not be interpreted as representing official policies,
!either expressed or implied, of the NHDS project.

subroutine calc_chi(chi,j,kz,kperp,x)
use input_params
implicit none
double complex :: chi(3,3),Y(3,3),Ynew(3,3),x
double precision :: kz,kperp,z,besselI
integer :: j,n,i,k,nmaxrun
logical :: Bessel_run

z=0.5d0*(kperp*vtherm(j)/Omega(j))*(kperp*vtherm(j)/Omega(j))*alpha(j)

do i=1,3
 do k=1,3
  Y(i,k)=0.d0
 enddo
enddo

! Determine maximum n for Besselfunction:
nmaxrun=nmax
n=0
Bessel_run=.TRUE.
do while (Bessel_run)
  if ((n.GE.nmax).OR.(besselI(n,z).LT.Bessel_zero)) then
     nmaxrun=n
     Bessel_run=.FALSE.
  endif
  n=n+1
enddo

if ((n.GE.nmax).AND.(output_warning)) then
 write (*,*) "WARNING: Insufficient order of Bessel function (nmax)."
 stop
endif

do n=-nmaxrun,nmaxrun
   call calc_ypsilon(Ynew,j,n,kz,kperp,x)
   do i=1,3
    do k=1,3
      Y(i,k)=Y(i,k)+exp(-z)*Ynew(i,k)
    enddo
   enddo
enddo

chi(1,1)=Y(1,1)/(x*ell(j)*ell(j))
chi(1,2)=Y(1,2)/(x*ell(j)*ell(j))
chi(1,3)=Y(1,3)/(x*ell(j)*ell(j))
chi(2,1)=Y(2,1)/(x*ell(j)*ell(j))
chi(2,2)=Y(2,2)/(x*ell(j)*ell(j))
chi(2,3)=Y(2,3)/(x*ell(j)*ell(j))
chi(3,1)=Y(3,1)/(x*ell(j)*ell(j))
chi(3,2)=Y(3,2)/(x*ell(j)*ell(j))
chi(3,3)=2.d0*vdrift(j)/(ell(j)*ell(j)*x*kz*vtherm(j)*vtherm(j)*alpha(j))+Y(3,3)/(x*ell(j)*ell(j))

end subroutine


subroutine calc_ypsilon(Y,j,n,kz,kperp,x)
use input_params
implicit none
double complex :: zeta,x,Y(3,3),An,Bn,resfac,dispfunct
double precision :: kz,kperp,BInz,z
double precision :: besselI
double precision :: dBInzdz
integer :: n,j
logical :: kpos

kpos=.TRUE.
if (kz.LT.0.d0) kpos=.FALSE.

zeta=(x-kz*vdrift(j)-1.d0*n*Omega(j))/(kz*vtherm(j))
resfac=x-kz*vdrift(j)-1.d0*n*Omega(j)
z=0.5d0*(kperp*vtherm(j)/Omega(j))*(kperp*vtherm(j)/Omega(j))*alpha(j)

An=(1.d0/x)*(alpha(j)-1.d0)
An=An+(1.d0/(kz*x*vtherm(j))) *( alpha(j)*resfac + 1.d0*n*Omega(j))*dispfunct(zeta,kpos)

Bn=(alpha(j)*(x-1.d0*n*Omega(j))-(kz*vdrift(j)-1.d0*n*Omega(j)))/(kz*x)
Bn=Bn+((x-1.d0*n*Omega(j))*(alpha(j)*resfac+1.d0*n*Omega(j))/(kz*kz*vtherm(j)*x) )*dispfunct(zeta,kpos)

if (n.GE.0) then
	BInz=1.d0*besselI(n,z)
	dBInzdz=besselI(n+1,z)+1.d0*n*BInz/z
else
	BInz=1.d0*besselI(-n,z)
	dBInzdz=besselI(-n-1,z)+1.d0*n*BInz/z
endif

! The tensor in Stix's (10-57)
Y(1,1)=1.d0*(n*n)*BInz*An/z
Y(1,2)=-uniti*n*(BInz-dBInzdz)*An
Y(1,3)=kperp*n*BInz*Bn/(Omega(j)*z)
Y(2,1)=uniti*n*(BInz-dBInzdz)*An
Y(2,2)=(1.d0*(n*n)*BInz/z+2.d0*z*BInz-2.d0*z*dBInzdz)*An
Y(2,3)=uniti*kperp*(BInz-dBInzdz)*Bn/Omega(j)
Y(3,1)=kperp*BInz*n*Bn/(Omega(j)*z)
Y(3,2)=-uniti*kperp*(BInz-dBInzdz)*Bn/Omega(j)
Y(3,3)=2.d0*(x-1.d0*n*Omega(j))*BInz*Bn/(kz*vtherm(j)*vtherm(j)*alpha(j))

end subroutine


function besselI(n,x)
implicit none
double precision :: besselI,x,BESSI
integer :: n

if (n.LT.0) then
	besselI=BESSI(-n,x)
else
	besselI=BESSI(n,x)
endif

end function



!************************************************************************
!*                                                                      *
!*    Program to calculate the first kind modified Bessel function of   *
!*    integer order N, for any REAL X, using the function BESSI(N,X).   *
!*                                                                      *
!* -------------------------------------------------------------------- *
!* -------------------------------------------------------------------- *
!*   Reference: From Numath Library By Tuan Dang Trong in Fortran 77.   *
!*                                                                      *
!*                               F90 Release 1.1 By J-P Moreau, Paris.  *
!*                                                                      *
!*   Version 1.1: corected value of P4 in BESSIO (P4=1.2067492 and not  *
!*                1.2067429) Aug. 2011.                                 *
!************************************************************************


! ----------------------------------------------------------------------
      FUNCTION BESSI(N,X)
!
!     This subroutine calculates the first kind modified Bessel function
!     of integer order N, for any REAL X. We use here the classical
!     recursion formula, when X > N. For X < N, the Miller's algorithm
!     is used to avoid overflows.
!     REFERENCE:
!     C.W.CLENSHAW, CHEBYSHEV SERIES FOR MATHEMATICAL FUNCTIONS,
!     MATHEMATICAL TABLES, VOL.5, 1962.
!
      PARAMETER (IACC = 40,BIGNO = 1.D10, BIGNI = 1.D-10)
      REAL *8 X,BESSI,BESSI0,BESSI1,TOX,BIM,BI,BIP
      IF (N.EQ.0) THEN
      BESSI = BESSI0(X)
      RETURN
      ENDIF
      IF (N.EQ.1) THEN
      BESSI = BESSI1(X)
      RETURN
      ENDIF
      IF(X.EQ.0.D0) THEN
      BESSI=0.D0
      RETURN
      ENDIF
      TOX = 2.D0/X
      BIP = 0.D0
      BI  = 1.D0
      BESSI = 0.D0
      M = 2*((N+INT(SQRT(FLOAT(IACC*N)))))
      DO 12 J = M,1,-1
      BIM = BIP+DFLOAT(J)*TOX*BI
      BIP = BI
      BI  = BIM
      IF (ABS(BI).GT.BIGNO) THEN
      BI  = BI*BIGNI
      BIP = BIP*BIGNI
      BESSI = BESSI*BIGNI
      ENDIF
      IF (J.EQ.N) BESSI = BIP
   12 CONTINUE
      BESSI = BESSI*BESSI0(X)/BI
      RETURN
      END
! ----------------------------------------------------------------------
! Auxiliary Bessel functions for N=0, N=1
      FUNCTION BESSI0(X)
      REAL *8 X,BESSI0,Y,P1,P2,P3,P4,P5,P6,P7,  &
      Q1,Q2,Q3,Q4,Q5,Q6,Q7,Q8,Q9,AX,BX
      DATA P1,P2,P3,P4,P5,P6,P7/1.D0,3.5156229D0,3.0899424D0,1.2067492D0,  &
      0.2659732D0,0.360768D-1,0.45813D-2/
      DATA Q1,Q2,Q3,Q4,Q5,Q6,Q7,Q8,Q9/0.39894228D0,0.1328592D-1, &
      0.225319D-2,-0.157565D-2,0.916281D-2,-0.2057706D-1,  &
      0.2635537D-1,-0.1647633D-1,0.392377D-2/
      IF(ABS(X).LT.3.75D0) THEN
      Y=(X/3.75D0)**2
      BESSI0=P1+Y*(P2+Y*(P3+Y*(P4+Y*(P5+Y*(P6+Y*P7)))))
      ELSE
      AX=ABS(X)
      Y=3.75D0/AX
      BX=EXP(AX)/SQRT(AX)
      AX=Q1+Y*(Q2+Y*(Q3+Y*(Q4+Y*(Q5+Y*(Q6+Y*(Q7+Y*(Q8+Y*Q9)))))))
      BESSI0=AX*BX
      ENDIF
      RETURN
      END
! ----------------------------------------------------------------------
      FUNCTION BESSI1(X)
      REAL *8 X,BESSI1,Y,P1,P2,P3,P4,P5,P6,P7,  &
      Q1,Q2,Q3,Q4,Q5,Q6,Q7,Q8,Q9,AX,BX
      DATA P1,P2,P3,P4,P5,P6,P7/0.5D0,0.87890594D0,0.51498869D0,  &
      0.15084934D0,0.2658733D-1,0.301532D-2,0.32411D-3/
      DATA Q1,Q2,Q3,Q4,Q5,Q6,Q7,Q8,Q9/0.39894228D0,-0.3988024D-1, &
      -0.362018D-2,0.163801D-2,-0.1031555D-1,0.2282967D-1, &
      -0.2895312D-1,0.1787654D-1,-0.420059D-2/
      IF(ABS(X).LT.3.75D0) THEN
      Y=(X/3.75D0)**2
      BESSI1=X*(P1+Y*(P2+Y*(P3+Y*(P4+Y*(P5+Y*(P6+Y*P7))))))
      ELSE
      AX=ABS(X)
      Y=3.75D0/AX
      BX=EXP(AX)/SQRT(AX)
      AX=Q1+Y*(Q2+Y*(Q3+Y*(Q4+Y*(Q5+Y*(Q6+Y*(Q7+Y*(Q8+Y*Q9)))))))
      BESSI1=AX*BX
      ENDIF
      RETURN
      END
! ----------------------------------------------------------------------
